package com.kingdee.eas.custom.projectbonus.app;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.projectbonus.BonusCycleBusDepProjectAssPersonnelDetailInfo;
import com.kingdee.util.DateTimeUtils;
import org.apache.log4j.Logger;

import java.math.BigDecimal;
import java.util.Date;

public class BonusCycleBusDepProjectAssPersonnelDetailControllerBean extends AbstractBonusCycleBusDepProjectAssPersonnelDetailControllerBean {
    private static Logger logger =
            Logger.getLogger(BonusCycleBusDepProjectAssPersonnelDetailControllerBean.class);

    /**
     * 
     *
     * @param ctx
     * @param model
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _save(Context ctx,
                              IObjectValue model) throws BOSException, EASBizException {
        BonusCycleBusDepProjectAssPersonnelDetailInfo info = (BonusCycleBusDepProjectAssPersonnelDetailInfo) model;
        //
        Date bonusStartingDate = info.getBonusStartingDate();
        //޽ֹ
        Date bonusDueDate = info.getBonusDueDate();
        long day = DateTimeUtils.dateDiff(bonusDueDate, bonusStartingDate) / 180L;
        //
        BigDecimal attendanceRate = new BigDecimal(String.valueOf(day));
        info.setAttendanceRate(attendanceRate);
        //Q1Чϵ
        BigDecimal performanceCoeffQ1 = info.getPerformanceCoeffQ1();
        //Q2Чϵ
        BigDecimal performanceCoeffQ2 = info.getPerformanceCoeffQ1();
        //˿ϵ
        BigDecimal assessmentCoeff = performanceCoeffQ1.add(performanceCoeffQ2).divide(BigDecimal.valueOf(2));
        info.setAssessmentCoeff(assessmentCoeff);
        //ְϵ
        BigDecimal functionCoefficient = info.getFunctionCoefficient();
        //Ͷϵ
        BigDecimal energyInputCoeff = info.getEnergyInputCoeff();
        //ְϵ
        BigDecimal rankCoefficient = info.getRankCoefficient();
        //ְϵ*Ͷϵ**ְϵ*˿ϵ
        BigDecimal cumulative = functionCoefficient.multiply(energyInputCoeff)
                .multiply(attendanceRate).multiply(rankCoefficient).multiply(assessmentCoeff);
        info.setCumulative(cumulative);
        //˽ռ = ݣְϵ *  * Ͷϵ * ְϵ * ˿ϵ/ ͬҵ£ְϵ *  * Ͷϵ * ְϵ * ˿ϵ֮ͼó
        info.setBonusProportion(null);
        //ְ
        BigDecimal bonusSubcontract = info.getBonusSubcontract();
        //˳ʼ
        BigDecimal initialProportion = info.getInitialProportion();
        //ڸ˽ = ְ * ˳ʼ * ˽ռ
        BigDecimal indivBonusAmount = bonusSubcontract.multiply(initialProportion).multiply(null);
        info.setIndivBonusAmount(indivBonusAmount);
        return super._save(ctx, model);
    }
}