package com.kingdee.eas.custom.projectbonus.app;

import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.shr.base.syssetting.BaseItemException;
import com.kingdee.shr.base.syssetting.StateEnum;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;
import com.kingdee.bos.*;
import com.kingdee.eas.custom.projectbonus.BonusCycleBusDepProjectInfo;
import com.kingdee.bos.metadata.entity.SelectorItemCollection;
import com.kingdee.eas.common.EASBizException;

import java.lang.String;

public class BonusCycleBusDepProjectControllerBean extends AbstractBonusCycleBusDepProjectControllerBean {
    private static Logger logger =
            Logger.getLogger(BonusCycleBusDepProjectControllerBean.class);

    /**
     * 
     *
     * @param ctx
     * @param billId id
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _enable(Context ctx,
                           String billId) throws BOSException, EASBizException {
        //super._enable(ctx, billId);
        if (StringUtils.isEmpty(billId)) {
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"idΪգ"});
        }
        BonusCycleBusDepProjectInfo info = getBonusCycleBusDepProjectInfo(ctx, new ObjectUuidPK(billId));
        StateEnum state = info.getState();
        if (!StateEnum.Enable.equals(state)) {
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("state");
            info.setState(StateEnum.Enable);
            try {
                updatePartial(ctx, info, sic);
            } catch (Exception e) {
                e.printStackTrace();
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{e.getMessage()});
            }
        }
    }

    /**
     * 
     *
     * @param ctx
     * @param billId id
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _disable(Context ctx,
                            String billId) throws BOSException, EASBizException {
        if (StringUtils.isEmpty(billId)) {
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"idΪգ"});
        }
        BonusCycleBusDepProjectInfo info = getBonusCycleBusDepProjectInfo(ctx, new ObjectUuidPK(billId));
        StateEnum state = info.getState();
        if (!StateEnum.Disable.equals(state)) {
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("state");
            info.setState(StateEnum.Disable);
            try {
                updatePartial(ctx, info, sic);
            } catch (Exception e) {
                e.printStackTrace();
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{e.getMessage()});
            }
        }
    }
}