package com.kingdee.eas.custom.projectbonus.app;

import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.custom.projectbonus.BonusCycleBusDepProjectCollection;
import com.kingdee.eas.framework.CoreBillBaseInfo;
import org.apache.log4j.Logger;
import com.kingdee.bos.*;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.eas.custom.projectbonus.BonusCycleInfo;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.eas.common.EASBizException;

import java.lang.String;

public class BonusCycleControllerBean extends AbstractBonusCycleControllerBean {
    private static Logger logger =
            Logger.getLogger(BonusCycleControllerBean.class);

    /**
     *  ظУ
     *
     * @param ctx
     * @param model
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _save(Context ctx, IObjectValue model) throws BOSException, EASBizException {
        BonusCycleInfo info = (BonusCycleInfo) model;
        String cycleName = info.getCycleName();//
        String id = null;
        if (info.getId() != null) {
            id = info.getId().toString();
        }
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        filterItems.add(new FilterItemInfo("cycleName", cycleName));
        filterItems.add(new FilterItemInfo("id", id, CompareType.NOTEQUALS));
        if (_exists(ctx, filterInfo)) {
            String errorMsg = "[ " + cycleName + " ]Ѿڣظ";
            logger.error(errorMsg);
            throw new BOSException(errorMsg);
        }
        return super._save(ctx, model);
    }


    /**
     * ܷɾ
     *
     * @param ctx
     * @param pk
     * @param coreBillInfo
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void isCanDelete(Context ctx,
                               IObjectPK pk,
                               CoreBillBaseInfo coreBillInfo)
            throws BOSException, EASBizException {
        super.isCanDelete(ctx, pk, coreBillInfo);
        SelectorItemCollection selector = new SelectorItemCollection();
        selector.add(new SelectorItemInfo("BusDepProject.id"));
        BonusCycleInfo info = (BonusCycleInfo) this.getCoreBillBaseInfo(ctx, pk, selector);
        BonusCycleBusDepProjectCollection busDepProjectCols = info.getBusDepProject();
        if (busDepProjectCols.size() > 0) {
            logger.error("ɾҵĿ");
            throw new BOSException("ɾҵĿ");
        }
    }
}